
local gr = love.graphics

function love.load()

	screen = { w = 500, h = 400 }
	love.window.setMode( screen.w, screen.h )
	love.window.setTitle( '"Z" order' )

	tree  = gr.newImage( 'tree.png' )
	space = gr.newImage( '3234.png' )

	object = {	{image=tree,x= 	75,y=350,z= 30,s=1.75},{image=tree,x=300,y=170,z=250,s= 0.75},
				{image=tree,x= 410,y=220,z=100,s=1.2 },{image=tree,x=210,y=370,z= 10,s= 2.00},
				{image=tree,x= 	60,y=200,z=110,s=1   },{image=tree,x=365,y=360,z= 27,s= 2.00},
				{image=tree,x= 200,y=280,z= 90,s=2.3 },{image=space,x=20,y=250,z= 20,s= 1.00} }

	orbit = { x = 150, y = -50 , an = 0, image = space, id = nil }

	end

function love.draw()

	for i = 1, #object do

		if i < orbit.id then gr.setColor(1,.2,.2) else gr.setColor(1,1,1) end

		gr.draw(
			object[i].image,
			object[i].x,
			object[i].y,
			0,
			object[i].s,
			object[i].s,
			object[i].image:getWidth()/2,
			object[i].image:getHeight())
		end

	gr.print( 'z: '..math.floor(object[orbit.id].z)..'  s: '..math.floor(100*object[orbit.id].s)/100,10,380)
	gr.print( 'Red trees are behind craft.',270, 10 )
	gr.print( 'fps: '..love.timer.getFPS(), 0, 0 )

	end

function love.update( dt )

	orbit.an = orbit.an + dt

	for i = 1,#object do
		orbit.id = nil
		if object[i].image == orbit.image then
			orbit.id = i
			break
			end
		end

	if orbit.id then
		object[orbit.id].x	= orbit.x*math.cos(orbit.an) + screen.w/2
		object[orbit.id].y	= orbit.y*math.sin(orbit.an) + screen.h/2
		object[orbit.id].z	= screen.h/2 - orbit.y - 0.9 * object[orbit.id].y
		object[orbit.id].s 	= object[orbit.id].y/200
		sortArray( object, 'z', 'd' )
		end

	end

function love.keypressed( key )
	if key == "escape" then love.event.quit() end
	end

function sortArray( tb, field, order )

	assert( type( field ) == 'string','Error:Sort field must be a string!')

	local order = order or 'i'		-- default = table sorted by increasing field values
	order = string.sub( order, 1, 1  )

	local sortFunc = function( a, b )
		if order == 'i' then
			return a[field] < b[field]
			else
			return a[field] > b[field]
			end
		end

	table.sort( tb, sortFunc )

	end

